/*
 *
 *  Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

package org.apache.royale.compiler.config;

/**
 * Constants for the compiler's diagnostic output.
 */
public class CompilerDiagnosticsConstants
{
	public static int diagnostics = 0;
    public static final int NODE_REFERENCES = 1;
    public static final int COUNTER = 2;
    public static final int CLASS_DEFINITION_BASE = 4;
    public static final int SYNCHRONIZED_GRAPH = 8;
    public static final int ASTOKEN = 16;
    public static final int CONFIG_MANAGER = 32;
    public static final int ASSCOPECACHE = 64;
    public static final int FILE_NODE = 128;
    public static final int WORKSPACE = 256;
    public static final int SYMBOL_DECORATOR_PROVIDER = 512;
    public static final int INT_MAP = 1024;
    public static final int DA_BYTEARRAY = 2048;
    public static final int FILE_UTILS = 4096;
    public static final int ROYALEJSPROJECT = 8192;
    public static final int COMPC_PHASES = 16384;
    public static final int GOOG_DEPS = 32768;

}
